//--- common JavaScript functions and objects ---

//--- tag ---
//---
//^O␳
function sTr(sVal)
{
	sVal = sNZ(sVal);
	sVal = sVal.replace(/"/g, "&quot;");
	sVal = sVal.replace(/</g, "&lt;");
	sVal = sVal.replace(/>/g, "&gt;");
	return sVal;
}
//---
//innerHTMLo
function vWriteHTML(oDoc, sId, sStr)
{
	if(document.all)					//IE
		oDoc.all(sId).innerHTML = sStr;
	else if(document.getElementById)	//NN6
		oDoc.getElementById(sId).innerHTML = sStr;
	else if(document.layers)			//NN4
	{
		with(oDoc.layers[sId].document)
		{
			open();
			write(sStr);
			close();
		}
	}
}
//---
//visivility؂ւ
function vSetVisible(sId, iShow)
{
	var sOn;
	var sOff;
	var bSw;
	var o;

	if(document.all)
	{
		//IE5
		o = document.all.item(sId).style;
		sOn = "visible";
		sOff = "hidden";
	}
	else if(document.getElementById)
	{
		//NN6(mF)
		o = document.getElementById(sId).style;
		sOn = "visible";
		sOff = "hidden";
	}
	else
	{
		//NN4
		o = document.layers[sId];
		sOn = "show";
		sOff = "hide";
	}

	if(isNaN(iShow))
		bSw = o.visibility != sOn;
	else
		bSw = iShow == 1;
	o.visibility = (bSw)? sOn: sOff;
	o.position = "relative";

	return void(0);
}
//---
//show؂ւ
//iShow=none:Toggle, 1:On, 2:Off
function vSetShow(sId, iShow)
{
	var sOn = "block";
	var sOff = "none";
	var bSw;
	var o;

	if(document.all)
		//IE5
		o = document.all.item(sId).style;
	else if(document.getElementById)
		//NN6(mF)
		o = document.getElementById(sId).style;
	else
		//NN4
		o = document.layers[sId];

	if(isNaN(iShow))
		bSw = o.display != sOn;
	else
		bSw = iShow == 1;
	o.display = (bSw)? sOn: sOff;

	return void(0);
}
//---
//text show؂ւ
function vSetTextEnabled(oEl, bEnabled)
{
	if(typeof(oEl.disabled) != "undefined")
		oEl.disabled = !bEnabled;
}
//---
//Select radiobutton
function nSelectRbn(oEl, iIdx)
{
	if(oEl && iNZ(oEl.length) != 0)
	{
		if(iIdx >= 0 && iIdx < oEl.length && !oEl[iIdx].checked)
			oEl[iIdx].checked = true;
	}
	return void(0);
}
//---
//Select Combobox
function nSelectCbx(oEl, sValue, bTxt)
{
	if(oEl && iNZ(oEl.length) != 0)
	{
		var i = oEl.length - 1;
		if(bTxt)
		{
			while(i >= 0 && oEl.options[i].text != sValue)
				i--;
		}
		else
		{
			while(i >= 0 && oEl.options[i].value != sValue)
				i--;
		}
		if(i >= 0)
			oEl.selectedIndex = i;
	}
	return void(0);
}
//---
//get index of radiobotton
function iGetIdxRbn(oEl, bDefault)
{
	var i = -1;
	if(oEl && (i = iNZ(oEl.length)) != 0)
	{
		if(bDefault)
		{
			while(--i >= 0 && !oEl[i].defaultChecked)
				;
		}
		else
		{
			while(--i >= 0 && !oEl[i].checked)
				;
		}
	}
	return i;
}
//---
//get index of combobox
function iGetIdxCbx(oEl, bDefault)
{
	var i = -1;
	if(oEl && (i = iNZ(oEl.length)) != 0)
	{
		if(bDefault)
		{
			while(--i >= 0 && !oEl[i].defaultSelected)
				;
		}
		else
			i = oEl.selectedIndex;
	}
	return i;
}
//---
//text2selectݒ
function vText2Cbx(oEl, oCbx)
{
	if(oEl == null || oCbx == null || oEl.value.length == 0)
		return;
	var i = oCbx.length - 1;
	while(i >= 0 &&
		oCbx.options[i].value.substr(0, oEl.value.length) != oEl.value)
		i--;
	if(i < 0)
		i = 0;
	if(oCbx.selectedIndex != i)
		oCbx.selectedIndex = i;
}
//---
//text2select(\猟)ݒ
function vText2Cbx2(oEl, oCbx)
{
	if(oEl == null || oCbx == null)
		return;
	var i = oCbx.length - 1;
	while(i >= 0 &&
		oCbx.options[i].text.indexOf(oEl.value) == -1)
		i--;
	if(i < 0)
		i = 0;
	if(oCbx.selectedIndex != i)
		oCbx.selectedIndex = i;
}
//---
//select2textݒ
function vCbx2Text(oEl, oTxt, iIdx, sSepa)
{
	if(oEl == null || oTxt == null)
		return;
	if(oEl.selectedIndex >= 0)
	{
		var s = oEl.options[oEl.selectedIndex].value;
		if(iIdx != null)
			s = s.split(sSepa)[iIdx];
		oTxt.value = s;
	}
}
//---
//Toggle checkbox
function nToggleChk(oEl)
{
	if(oEl)
	{
		if(document.all)	//IE
			oEl.checked = !oEl.checked;
		else				//NN6
			oEl.click();
	}
	return void(0);
}
//---
//Fݒ
function vSetColor(sId, sColor)
{
	var o;
	if(document.all)
		//IE5
		o = document.all.item(sId).style;
	else if(document.getElementById)
		//NN6(mF)
		o = document.getElementById(sId).style;
	else
		//NN4
		o = document.layers[sId];
	o.color = sColor;
}
//--- string ---
//---
//E񂹂ɂĕ
function sInt2RightStr(iVal, iLength, sPad)
{
	sPad = sNZ(sPad);
	sVal = sNZ(iVal);
	var s = "";
	for(var i = sVal.length; i < iLength; i++)
		s += sPad;
	return s + sVal;
}
//---
// ȉw茅\
function sFmtDot(dVal, iKeta)
{
	var bMinus = (dVal < 0);
	dVal = Math.abs(dVal);
	var iWk = iNZ(dVal);
	dVal = dNZ(dVal) - iWk + Math.pow(10, -1 * (iKeta + 1)) * 5.0001;
	var s = (bMinus? "-": "") + iWk + ".";
	
	for(var i = 0; i < iKeta; i++)
	{
		dVal *= 10;
		iWk = iNZ(dVal);
		dVal -= iWk;
		s += iWk;
	}
	return s;
}
//---
// 3J}tɂĕ
function sAddComma(sVal)
{
	var sShosu = sNZ(sVal);
	var i = sShosu.indexOf(".");
	sShosu = (i > 0? sShosu.substr(i): "");
	i = iNZ(sVal);
	var bMinus = (i < 0);
	var sVal = sNZ(Math.abs(i));
	var s = "";
	i = sVal.length - 1;
	var j = 0;
	while(i >= 0)
	{
		if((j % 3) == 0 && j != 0)
			s = "," + s;
		s = sVal.charAt(i) + s;
		j++;
		i--;
	}
	return (bMinus? "-" + s: s) + sShosu;
}
//---
//omit comma
function sOc(sVal)
{
	sVal = sNZ(sVal);
	sVal = sVal.replace(//g, "-");
	sVal = sVal.replace(/,/g, "");
	return sVal;
}
//---
//omit comma for element
function oOc(oEl)
{
	oEl.value = sOc(oEl.value);
	if(document.all ||				//IE
		document.getElementById)	//NN6
		oEl.style.color = "black";
	oEl.select();
}
//---
//add comma
function sAc(sVal, iSeisubu, iShosubu, bAbs)
{
	if(sVal == null || (typeof(sVal) == "string" && sVal == ""))
		return "";
	sVal = sOc(sVal);
	var s;
	if(!bAbs)
	{
		s = sNZ(sVal)
		if(s.indexOf(".") == -1)
			iShosubu = 0;
	}
	var i;
	if(iShosubu == false || iShosubu == 0)
	{
		i = iNZ(sVal);
		if(iSeisubu)
			i = i % Math.pow(10, iSeisubu);
		s = Math.abs(i);
	}
	else
	{
		i = dNZ(sVal);
		if(iSeisubu)
			i = i % Math.pow(10, iSeisubu);
		s = sFmtDot(Math.abs(i), iShosubu);
	}
	return (i < 0? "": "") + sAddComma(s);
}
//---
//add comma red
function sAcRed(sVal, iSeisubu, iShosubu, bAbs)
{
	var s = sAc(sVal, iSeisubu, iShosubu, bAbs);
	if(s.substr(0, 1) == "")
		s = '<font color="red">' + s + "</font>";

	return s;
}
//---
//add comma for element
function oAc(oEl, iSeisubu, iShosu, iBase, iType)
{
	if(oEl.value.length == 0)
		return;
	var d = dNZ(sOc(oEl.value));
	if(iBase)
		d = iMarume(d, iBase, iType);
	oEl.value = sAc(d, iSeisubu, iShosu);
	if(document.all ||				//IE
		document.getElementById)	//NN6
		oEl.style.color = (d < 0)?"red": "black";
}
//---
//lۂ (iType=0:ľܓ,-1:؂̂,1:؂グ)
function iMarume(iVal, iBase, iType)
{
	if(iVal == null)
		return null;
	var iAdd = 0;
	switch(iType)
	{
	case  0:	iAdd = iBase / 2;	break;
	case -1:	iAdd = 0;			break;
	case 1:		iAdd = iBase * 0.9;	break;
	}
	if(iVal < 0)
		iAdd *= -1;
	return parseInt((iVal + iAdd) / iBase) * iBase;
}
//---
//sNZ
function sNZ(v)
{
	return (v == null || typeof(v) == "undefined")? "": String(v);
}
//---
//iNZ
function iNZ(v)
{
	v = parseInt(v, 10);
	return (isNaN(v))? 0: v;
}
//---
//dNZ
function dNZ(v)
{
	v = parseFloat(v);
	return (isNaN(v))? 0: v;
}
//--- datetime ---
//---
//擾
function aaoGetRekiCgInf(aaoInf)
{
	if(!aaoInf)
	{
		//new
		var aaoNewInf = aaoGetRekiCgInfData;
		return aaoNewInf;
	}
	else
		return null;
}
aaoGetRekiCgInfData = new Array();
aaoGetRekiCgInfData.offs = new Array(     0,   1867,   1911,   1925,   1988);
aaoGetRekiCgInfData.name = new Array("", "", "吳", "a", "");
//---
//CfbNX擾
function iGetRekiIndix(aaoInf, v)
{
	var i = 0;
	if(typeof(v) == "number")
	{
		//Nw
		i = aaoInf.offs.length - 1;
		while(i > 0 && v <= aaoInf.offs[i])
			i--;
	}
	else if(typeof(v) == "string")
	{
		//w
		i = aaoInf.name.length - 1;
		while(i >= 0 && aaoInf.name[i] != v)
			i--;
	}
	return i;
}
//---
//NeLXg{bNXǂݎ
function oGetYMD(oForm, sName)
{
	var iY = 0;
	var s = (typeof(oForm.elements[sName + "W"]) != "undefined")?
		oForm.elements[sName + "W"].value: "";
	if(s.length != 0)
	{
		var aaoInf = aaoGetRekiCgInf();
		var i = iGetRekiIndix(aaoInf, s);
		iY = aaoInf.offs[i];
		aaoGetRekiCgInf(aaoInf);
	}
	iY += iNZ(oForm.elements[sName + "Y"].value);
	var iM = iNZ(oForm.elements[sName + "M"].value);
	var iD = iNZ(oForm.elements[sName + "D"].value);
	var oDate = (iY == 0 || iM == 0 || iD == 0?
		null: new Date(iY, iM - 1, iD));
	return oDate;
}
//---
// yyyy/mm/dd`̓t擾
function sDate2Str(oDate, sSpl)
{
	var s = null;
	if(!sSpl)
		sSpl = "";
	if(oDate && !isNaN(oDate))
		s = sInt2RightStr(oDate.getFullYear(), 4, "0") + sSpl +
		sInt2RightStr(oDate.getMonth() + 1, 2, "0") + sSpl +
		sInt2RightStr(oDate.getDate(), 2, "0");
	return s;
}
// yyyy/mm/dd`̓t񂩂Dateɕϊ
function oStr2Date(sYMD)
{
	sYMD = sNZ(sYMD);
	var oDate = null;

	if(sYMD == "")
		return oDate;

	var asWk = sYMD.split("/");
	if(asWk.length == 3)
		//XbV؂Őݒ
		oDate = new Date(iNZ(asWk[0]), iNZ(asWk[1]) - 1,
			iNZ(asWk[2]));
	else if(sYMD.length == 8)
		// yyyymmdd`
		oDate = new Date(iNZ(sYMD.substr(0, 4)),
			iNZ(sYMD.substr(4, 2)) - 1, iNZ(sYMD.substr(6, 2)));
	else
		//UTCŐݒ
		oDate = new Date(sYMD);

	return oDate;
}
//---
//^O֓tݒ iType=0:,1:a
function vSetDate2Tag(oDate, sName, iType)
{
	if(!oDate)
		return;
	with(document.MainForm)
	{
		var iY = oDate.getFullYear();
		if(iType == 0)
			elements[sName + "Y"].value = iY;
		else
		{
			var aaoInf = aaoGetRekiCgInf();
			var i = iGetRekiIndix(aaoInf, iY);
			elements[sName + "W"].selectedIndex = i;
			elements[sName + "Y"].value = iY - aaoInf.offs[i];
			aaoGetRekiCgInf(aaoInf);
		}
		elements[sName + "M"].value = oDate.getMonth() + 1;
		elements[sName + "D"].value = oDate.getDate();
	}
}
//---
//Nx擾
function iGetNendo(oDate)
{
	var iY = null;
	if(oDate)
	{
		iY = oDate.getFullYear();
		if(oDate.getMonth() + 1 <= 3)
			iY--;
	}
	return iY;
}
//--- etc ---
//---
//e-mail̓`FbN
function bCheckEmail(sVal)
{
	return /[a-zA-Z0-9_.\-]{2,}@[a-zA-Z0-9_.\-]+/g.test(String(sVal));
}
//---
//̓G[
function vAlertMsg(oEl, sMsg)
{
	if(document.all ||				//IE
		document.getElementById)	//NN6
	{
		var sFg = oEl.style.color;
		var sBg = oEl.style.backgroundColor;
		oEl.style.color = "white";
		oEl.style.backgroundColor = "red";
		alert(sMsg);
		oEl.style.color = sFg;
		oEl.style.backgroundColor = sBg;
	}
	else
		alert(sMsg);
	
	oEl.focus();
}
//---
//VKwindow open
function oOpenWin(sUrl, sName)
{
	return window.open(sUrl, sName,
		"width=788,height=523,menubar=yes,scrollbars=yes,resizable=yes");
}
//---
//`ChwindowN
aoOpenedChildWin = new Array();
function nOpenChildWin(sUrl, iNo)
{
	if(aoOpenedChildWin[iNo] && !aoOpenedChildWin[iNo].closed)
	{
		//focusȂƃG[ɂȂ邱Ƃ(IE5.01SP1)
		aoOpenedChildWin[iNo].focus();
		aoOpenedChildWin[iNo].location.href = sUrl;
	}
	else
	{
		aoOpenedChildWin[iNo] = oOpenWin(sUrl, "ChildWindow" + iNo);
		if(!aoOpenedChildWin[iNo])
			alert("EBhEJ܂ł");
	}

	return void(0);
}
